SystemOrganization addCategory: #WaffleLayout!
SystemOrganization addCategory: #'WaffleLayout-test'!
SystemOrganization addCategory: #'WaffleLayout-MorphicLayout'!

LayoutProperties subclass: #WaffleLayoutProperties
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout-MorphicLayout'!

WaffleLayoutProperties subclass: #WaffleLayoutMainProperties
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout-MorphicLayout'!

!WaffleLayoutMainProperties methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2013 19:09'!
isWaffleMain
	^true! !

WaffleLayoutProperties subclass: #WaffleLayoutSubProperties
	instanceVariableNames: 'rowIndex columnIndex rowRange columnRange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout-MorphicLayout'!

!WaffleLayoutSubProperties class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2013 13:07'!
rowIndex: aSmallInteger columnIndex: aSmallInteger2 
	^self new
		rowIndex: aSmallInteger;
		columnIndex: aSmallInteger2! !

!WaffleLayoutSubProperties class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2013 19:05'!
rowRange: range1 columnRange: range2 
	^self new
		rowRange: range1;
		columnRange: range2! !

!WaffleLayoutSubProperties methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2013 18:57'!
boundsWithWaffle: aWFWaffleLayout
	|startRect stopRect|
	startRect := aWFWaffleLayout boundsAtRow: rowRange start atColumn: columnRange start.
	stopRect := aWFWaffleLayout boundsAtRow: rowRange stop atColumn: columnRange stop.
	^startRect merge: stopRect.! !

!WaffleLayoutSubProperties methodsFor: 'accessing' stamp: 'HwaJong 1/17/2013 18:52'!
columnIndex: aSmallInteger 
	columnRange := Range close: aSmallInteger close: aSmallInteger! !

!WaffleLayoutSubProperties methodsFor: 'accessing' stamp: 'HwaJong 1/17/2013 19:04'!
columnRange: aRange 
	columnRange := aRange! !

!WaffleLayoutSubProperties methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2013 19:09'!
isWaffleMain
	^false! !

!WaffleLayoutSubProperties methodsFor: 'accessing' stamp: 'HwaJong 1/17/2013 18:52'!
rowIndex: aSmallInteger 
	rowRange := Range close: aSmallInteger close: aSmallInteger ! !

!WaffleLayoutSubProperties methodsFor: 'accessing' stamp: 'HwaJong 1/17/2013 19:04'!
rowRange: aRange 
	rowRange := aRange! !

TestCase subclass: #WFWaffleLayoutTest
	instanceVariableNames: 'waffle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout-test'!

!WFWaffleLayoutTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 18:12'!
setUp
	super setUp.
	waffle := WFWaffleLayout new.
	waffle addRows: 3 addColumns: 2 fixedGap: 5.! !

!WFWaffleLayoutTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2013 23:53'!
testHeightTooSmall
	self should: [waffle bounds: (0@0 extent: 15@19)] raise: Error.
! !

!WFWaffleLayoutTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2013 21:49'!
testHorizontalLinePosition
	waffle bounds: (0@0 extent: 301@200).	
	self assert: ((1 to: 8) collect: [:each| waffle horizontalLinePositionAt: each]) equals: #(0 5 65 70 130 135 195 200).
! !

!WFWaffleLayoutTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 18:16'!
testMinimalExtent
	waffle bounds: (0@0 extent: 15@20).
	self assert: (waffle boundsOfIndentationAtRow: 1 atColumn: 1) equals: ((5@5) corner: (5@5)).
	self assert: (waffle boundsOfIndentationAtRow: 1 atColumn: 2) equals: ((10@5) corner: (10@5)).
	self assert: (waffle boundsOfIndentationAtRow: 2 atColumn: 1) equals: ((5@10) corner: (5@10)).
	self assert: (waffle boundsOfIndentationAtRow: 2 atColumn: 2) equals: ((10@10) corner: (10@10)).
	self assert: (waffle boundsOfIndentationAtRow: 3 atColumn: 1) equals: ((5@15) corner: (5@15)).
	self assert: (waffle boundsOfIndentationAtRow: 3 atColumn: 2) equals: ((10@15) corner: (10@15)).
! !

!WFWaffleLayoutTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 18:14'!
testProperExtent
	waffle bounds: (0@0 extent: 301@200).
	self assert: (waffle boundsOfIndentationAtRow: 1 atColumn: 1) equals: ((5@5) corner: (148@65)).
	self assert: (waffle boundsOfIndentationAtRow: 1 atColumn: 2) equals: ((153@5) corner: (296@65)).
	self assert: (waffle boundsOfIndentationAtRow: 2 atColumn: 1) equals: ((5@70) corner: (148@130)).
	self assert: (waffle boundsOfIndentationAtRow: 2 atColumn: 2) equals: ((153@70) corner: (296@130)).
	self assert: (waffle boundsOfIndentationAtRow: 3 atColumn: 1) equals: ((5@135) corner: (148@195)).
	self assert: (waffle boundsOfIndentationAtRow: 3 atColumn: 2) equals: ((153@135) corner: (296@195)).
! !

!WFWaffleLayoutTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2013 21:50'!
testVerticalLinePosition
	waffle bounds: (0@0 extent: 301@200).
	self assert: ((1 to: 6) collect: [:each| waffle verticalLinePositionAt: each]) equals: #(0 5 148 153 296 301)! !

!WFWaffleLayoutTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2013 23:52'!
testWidthTooSmall
	self should: [waffle bounds: (0@0 extent: 14@20)] raise: Error.
! !

TestCase subclass: #WFWaffleSideTest
	instanceVariableNames: 'side'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout-test'!

!WFWaffleSideTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 17:50'!
setUp
	super setUp.
	side := WFWaffleSide new.! !

!WFWaffleSideTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/11/2013 13:42'!
testBoundaryNaming
	side addSegment: (WFFixedSegment number: 2).
	side addSegment: (WFProportionalSegment number: 1).
	side range: (Range close: 100 open: 103).
	
	side name: 'z' boundaryAt: 1.
	side name: 'r' boundaryAt: 2.
	side name: 'u' boundaryAt: 3.
	
	self assert: (side boundaryPositionByName: 'z') equals: 100.
	self assert: (side boundaryPositionByName: 'r') equals: 102.
	self assert: (side boundaryPositionByName: 'u') equals: 103.! !

!WFWaffleSideTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2013 21:37'!
testBoundaryPosition
	side addSegment: (WFFixedSegment number: 2).
	side addSegment: (WFProportionalSegment number: 1).
	side range: (Range close: 100 open: 103).
	
	self assert: (side boundaryPositionAt: 1) equals: 100.
	self assert: (side boundaryPositionAt: 2) equals: 102.
	self assert: (side boundaryPositionAt: 3) equals: 103.! !

!WFWaffleSideTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 18:01'!
testDifferenceBetweenFixedSegmentAndProportionalSegment
	side addSegment: (WFFixedSegment number: 2).
	side addSegment: (WFProportionalSegment number: 1).
	
	side range: (Range close: 0 open: 2).
	self assert: (side segments collect: #length) asArray equals: {2. 0}.
	
	side range: (Range close: 0 open: 3).
	self assert: (side segments collect: #length) asArray equals: {2. 1}.
	
	side range: (Range close: 0 open: 4).
	self assert: (side segments collect: #length) asArray equals: {2. 2}.
	
	side range: (Range close: 0 open: 5).
	self assert: (side segments collect: #length) asArray equals: {2. 3}.! !

!WFWaffleSideTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 18:03'!
testProportions
	side addSegment: (WFProportionalSegment number: 3).
	side addSegment: (WFFixedSegment number: 2).
	side addSegment: (WFProportionalSegment number: 1).
	
	side range: (Range close: 0 open: 2).
	self assert: (side segments collect: #length) asArray equals: {0. 2. 0}.
	
	side range: (Range close: 0 open: 6).
	self assert: (side segments collect: #length) asArray equals: {3. 2. 1}.

	side range: (Range close: 0 open: 10).
	self assert: (side segments collect: #length) asArray equals: {6. 2. 2}.

	side range: (Range close: 0 open: 14).
	self assert: (side segments collect: #length) asArray equals: {9. 2. 3}.! !

!WFWaffleSideTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/11/2013 16:38'!
testSegmentNaming
	side addSegment: (WFProportionalSegment number: 3) withName: 's1'.
	side addSegment: (WFFixedSegment number: 2) withName: 's2'.
	side addSegment: (WFProportionalSegment number: 1).
	
	side name: 's3' segmentAt: 3.
	
	side range: (Range close: 0 open: 14).
	
	self assert: (side segmentByName: 's1') length equals: 9.
	"self assert: (side segments collect: #length) asArray equals: {9. 2. 3}."! !

!WFWaffleSideTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/13/2013 23:50'!
testTooSmall
	side addSegment: (WFFixedSegment number: 2).
	side addSegment: (WFProportionalSegment number: 1).
	
	self should: [side range: (Range close: 0 open: 1)] raise: Error.

! !

LayoutPolicy subclass: #WaffleLayout
	instanceVariableNames: 'waffleModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout-MorphicLayout'!

!WaffleLayout class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/17/2013 20:04'!
example
| waffle l m s1 s2 s3 s4 |
waffle := WFWaffleLayout new.
waffle addRows: 3 addColumns: 2 fixedGap: 5.
l := WaffleLayout new waffleModel: waffle.

m := Morph new.
m layoutPolicy: l.
m layoutProperties: WaffleLayoutMainProperties new.
m openInWorld.

s1 := Morph new.
s1 layoutPolicy: l.
s1 layoutProperties: (WaffleLayoutSubProperties rowIndex: 2 columnIndex: 2).
s1 color: Color green.
m addMorph: s1.

s2 := Morph new.
s2 layoutPolicy: l.
s2 layoutProperties: (WaffleLayoutSubProperties rowIndex: 2 columnIndex: 4).
s2 color: Color red.
m addMorph: s2.

s3 := Morph new.
s3 layoutPolicy: l.
s3 layoutProperties: (WaffleLayoutSubProperties rowRange: (Range close: 4 close: 6) columnRange: (Range close: 2 close: 2)).
s3 color: Color gray.
m addMorph: s3.

s4 := Morph new.
s4 layoutPolicy: l.
s4 layoutProperties: (WaffleLayoutSubProperties rowRange: (Range close: 4 close: 6) columnRange: (Range close: 4 close: 4)).
s4 color: Color lightRed.
m addMorph: s4.


m extent: 100@90.
m bounds: Rectangle fromUser.
m layoutChanged.


m openInWindow.


m delete.
! !

!WaffleLayout methodsFor: 'layout' stamp: 'HwaJong 1/17/2013 19:09'!
layout: aMorph in: newBounds
	|waffle|
	waffle := self waffleModel.
	aMorph layoutProperties isWaffleMain
		ifTrue: [
			waffle bounds: newBounds].
	aMorph submorphsDo:[:m| 
		(m layoutPolicy isKindOf: WaffleLayout)
			ifTrue: [m bounds: (m layoutProperties boundsWithWaffle: waffle)]].
! !

!WaffleLayout methodsFor: 'accessing' stamp: 'HwaJong 1/17/2013 12:50'!
waffleModel
	^ waffleModel! !

!WaffleLayout methodsFor: 'accessing' stamp: 'HwaJong 1/17/2013 12:50'!
waffleModel: aWFWaffleLayout
	waffleModel := aWFWaffleLayout
! !

Object subclass: #WFSegment
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

WFSegment subclass: #WFFixedSegment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

!WFFixedSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:45'!
length

	^self number! !

!WFFixedSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:57'!
lengthIsFixed

	^true! !

!WFFixedSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:03'!
lengthIsProportional

	^false! !

WFSegment subclass: #WFProportionalSegment
	instanceVariableNames: 'waffleSide'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

!WFProportionalSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 12:02'!
defaultWaffleSide

	|side|
	side :=  WFWaffleSide new.
	side addSegment: self.    
	^side! !

!WFProportionalSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:12'!
length
	^ self proportion * self waffleSide absoluteLengthPerProportion! !

!WFProportionalSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:03'!
lengthIsProportional
	^true! !

!WFProportionalSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:47'!
proportion

	^self number! !

!WFProportionalSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:48'!
waffleSide

	^waffleSide setDefault: #defaultWaffleSide for: self withSetter: #waffleSide:! !

!WFProportionalSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:49'!
waffleSide: aWFWaffleSide 

	waffleSide := aWFWaffleSide! !

!WFSegment class methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 09:21'!
number: aNumber

	^self new number: aNumber! !

!WFSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:44'!
defaultNumber

	^1! !

!WFSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:58'!
lengthIsFixed

	^false! !

!WFSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:43'!
number

	^number setDefault: #defaultNumber for: self  withSetter: #number:! !

!WFSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:43'!
number: aNumber

	number := aNumber! !

!WFSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:00'!
waffleSide: aWFWaffleSide 
! !

Object subclass: #WFWaffleLayout
	instanceVariableNames: 'columnSegments rowSegments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

!WFWaffleLayout class methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 16:04'!
example1

	| mainMorph waffle subs |
	mainMorph := RectangleMorph new.
	mainMorph extent: 400@300.
	mainMorph openInWindow.

	waffle := WFWaffleLayout new.
	waffle bounds: mainMorph bounds.
	waffle addRows: 3 addColumns: 2 fixedGap: 5.

	subs := Matrix rows: 3 columns: 2.

	1 to: 3 do: [:r|
		1 to: 2 do: [:c| |sub|
			sub := RectangleMorph new.
			mainMorph addMorph: sub.
			subs at: r at: c put: sub. 
			]
		].

	"You can repeat code below whenever the mainMorph's extent is changed."
	waffle bounds: mainMorph bounds.
	subs withIndicesDo: [:sub :r :c| 
		waffle placeMorph: sub atRow: r atColumn: c.].! !

!WFWaffleLayout methodsFor: 'adding segment' stamp: 'hjo 11/28/2011 12:02'!
addColumnSegment: aWFSegment 

	self columnSegments addSegment: aWFSegment! !

!WFWaffleLayout methodsFor: 'adding segment' stamp: 'HwaJong 2/12/2013 07:02'!
addColumnSegment: aWFSegment withName: aString 
	^self columnSegments addSegment: aWFSegment withName: aString! !

!WFWaffleLayout methodsFor: 'adding conviently' stamp: 'HwaJong 2/12/2013 07:08'!
addFixedColumnSegment: aNumber 
	^self addColumnSegment: (WFFixedSegment number: aNumber).! !

!WFWaffleLayout methodsFor: 'adding conviently' stamp: 'HwaJong 2/12/2013 07:01'!
addFixedColumnSegment: aNumber withName: aString
	^self addColumnSegment: (WFFixedSegment number: aNumber) withName: aString.
! !

!WFWaffleLayout methodsFor: 'adding conviently' stamp: 'HwaJong 2/12/2013 07:09'!
addFixedRowSegment: aNumber
	^self addRowSegment: (WFFixedSegment number: aNumber).! !

!WFWaffleLayout methodsFor: 'adding conviently' stamp: 'HwaJong 2/12/2013 07:12'!
addFixedRowSegment: aNumber withName: aString 
	^self addRowSegment: (WFFixedSegment number: aNumber) withName: aString.! !

!WFWaffleLayout methodsFor: 'adding conviently' stamp: 'HwaJong 2/12/2013 07:09'!
addProportionalColumnSegment: aNumber 
	^self addColumnSegment: (WFProportionalSegment number: aNumber)! !

!WFWaffleLayout methodsFor: 'adding conviently' stamp: 'HwaJong 2/12/2013 07:06'!
addProportionalColumnSegment: aNumber withName: aString 
	^self addColumnSegment: (WFProportionalSegment number: aNumber) withName: aString.
! !

!WFWaffleLayout methodsFor: 'adding conviently' stamp: 'HwaJong 2/12/2013 06:39'!
addProportionalRowSegment: aNumber 
	|seg|
	seg := WFProportionalSegment number: aNumber.
	self addRowSegment: seg.
	^seg! !

!WFWaffleLayout methodsFor: 'adding segment' stamp: 'hjo 11/28/2011 12:02'!
addRowSegment: aWFSegment 

	self rowSegments addSegment: aWFSegment  ! !

!WFWaffleLayout methodsFor: 'adding segment' stamp: 'HwaJong 2/12/2013 07:14'!
addRowSegment: aWFSegment withName: aString 
	^self rowSegments addSegment: aWFSegment withName: aString ! !

!WFWaffleLayout methodsFor: 'adding conviently' stamp: 'hjo 11/28/2011 12:56'!
addRows: numberOfRowsToAdd addColumns: numberOfColumnsToAdd fixedGap: gapLength 

	self rowSegments addProportionalSegments: numberOfRowsToAdd fixedGap: gapLength.
	self columnSegments addProportionalSegments: numberOfColumnsToAdd fixedGap: gapLength.! !

!WFWaffleLayout methodsFor: 'bounds' stamp: 'hjo 11/28/2011 11:58'!
bounds

	^self privateGetBoundsFromXRange: (self columnSegments range) yRange:  (self rowSegments range)! !

!WFWaffleLayout methodsFor: 'bounds' stamp: 'hjo 11/28/2011 11:58'!
bounds: aRectangle 

	self rowSegments range: (Range close: aRectangle top open: aRectangle bottom).
	self columnSegments range: (Range close: aRectangle left open: aRectangle right).! !

!WFWaffleLayout methodsFor: 'bounds' stamp: 'HwaJong 12/29/2012 17:47'!
boundsAtRow: integer1 atColumn: integer2 

	|xRange yRange|
	xRange := self columnSegments rangeOfSegmentAtIndex: integer2.
	yRange := self rowSegments rangeOfSegmentAtIndex: integer1.
	^self privateGetBoundsFromXRange: xRange yRange: yRange.! !

!WFWaffleLayout methodsFor: 'bounds' stamp: 'hjo 11/28/2011 11:58'!
boundsOfIndentationAtRow: integer1 atColumn: integer2 

	|xRange yRange|
	xRange := self columnSegments rangeOfIndentationAtIndex: integer2.
	yRange := self rowSegments rangeOfIndentationAtIndex: integer1.
	^self privateGetBoundsFromXRange: xRange yRange:  yRange.! !

!WFWaffleLayout methodsFor: 'accessing' stamp: 'hjo 11/28/2011 12:13'!
columnSegments

	^ columnSegments setDefault: #defaultSegments for: self  withSetter:  #columnSegments:! !

!WFWaffleLayout methodsFor: 'accessing' stamp: 'hjo 11/28/2011 12:10'!
columnSegments: aWFWaffleSide 

	columnSegments := aWFWaffleSide! !

!WFWaffleLayout methodsFor: 'accessing' stamp: 'hjo 11/28/2011 12:12'!
defaultSegments

	^WFWaffleSide new! !

!WFWaffleLayout methodsFor: 'line position' stamp: 'HwaJong 1/15/2013 21:46'!
horizontalLinePositionAt: aSmallInteger 
	^rowSegments boundaryPositionAt: aSmallInteger! !

!WFWaffleLayout methodsFor: 'morphic' stamp: 'hjo 11/28/2011 13:41'!
placeMorph: aMorph atRow: integer1 atColumn: integer2
	
	aMorph bounds: (self boundsOfIndentationAtRow: integer1 atColumn: integer2).! !

!WFWaffleLayout methodsFor: 'bounds' stamp: 'hjo 11/28/2011 10:53'!
privateGetBoundsFromXRange: range1 yRange: range2

	^(range1 start @ range2 start) corner: (range1 stop @ range2 stop)! !

!WFWaffleLayout methodsFor: 'accessing' stamp: 'hjo 11/28/2011 12:13'!
rowSegments

	^ rowSegments setDefault: #defaultSegments for: self withSetter: #rowSegments:! !

!WFWaffleLayout methodsFor: 'accessing' stamp: 'hjo 11/28/2011 12:11'!
rowSegments: aWFWaffleSide 

	rowSegments := aWFWaffleSide! !

!WFWaffleLayout methodsFor: 'line position' stamp: 'HwaJong 1/15/2013 21:40'!
verticalLinePositionAt: anInteger 
	^columnSegments boundaryPositionAt: anInteger.! !

Object subclass: #WFWaffleSide
	instanceVariableNames: 'range absoluteLengthPerProportion segments boundaryFromNameToIndex nameToSegmentIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

!WFWaffleSide methodsFor: 'computing' stamp: 'hjo 11/28/2011 08:15'!
absoluteLengthPerProportion

	^absoluteLengthPerProportion setDefault: #defaultAbsoluteLengthPerProportion for: self withSetter: #absoluteLengthPerProportion:! !

!WFWaffleSide methodsFor: 'computing' stamp: 'hjo 11/28/2011 08:15'!
absoluteLengthPerProportion: aFloat 

	absoluteLengthPerProportion := aFloat! !

!WFWaffleSide methodsFor: 'adding segments' stamp: 'hjo 11/28/2011 12:54'!
addProportionalSegments: anInteger fixedGap: gapLength

	| addGap |
	addGap := [self addSegment: (WFFixedSegment number: gapLength)].
	addGap value.
	anInteger timesRepeat: [
			self addSegment: (WFProportionalSegment number: 1).
			addGap value]. ! !

!WFWaffleSide methodsFor: 'adding segments' stamp: 'hjo 11/28/2011 12:19'!
addSegment: aWFSegment 
	
	self absoluteLengthPerProportion: nil.
	self segments addLast: aWFSegment.
	aWFSegment waffleSide: self.  ! !

!WFWaffleSide methodsFor: 'segments' stamp: 'HwaJong 2/11/2013 14:04'!
addSegment: aWFSegment withName: aString 
	self addSegment: aWFSegment.
	self nameToSegmentIndex at: aString put: (segments indexOf: aWFSegment)! !

!WFWaffleSide methodsFor: 'accessing' stamp: 'HwaJong 2/11/2013 13:41'!
boundaryFromNameToIndex

	^boundaryFromNameToIndex setDefault: #defaultBoundaryFromNameToIndex for: self withSetter: #boundaryFromNameToIndex:! !

!WFWaffleSide methodsFor: 'accessing' stamp: 'HwaJong 2/11/2013 13:41'!
boundaryFromNameToIndex: anObject
		
	boundaryFromNameToIndex := anObject! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/15/2013 21:36'!
boundaryPositionAt: anInteger
	^self rangeStartOfSegmentAtIndex: anInteger! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/11/2013 13:43'!
boundaryPositionByName: aString 
	^self boundaryPositionAt: (self boundaryFromNameToIndex at: aString)! !

!WFWaffleSide methodsFor: 'computing' stamp: 'hjo 11/28/2011 12:20'!
defaultAbsoluteLengthPerProportion
	
	^self lengthThatProportionalSegmentsMayDivide / self sumOfProportions! !

!WFWaffleSide methodsFor: 'defaults' stamp: 'HwaJong 2/11/2013 13:41'!
defaultBoundaryFromNameToIndex

	"Return a default object for instance variable boundaryFromNameToIndex."
	^Dictionary new! !

!WFWaffleSide methodsFor: 'defaults' stamp: 'HwaJong 2/11/2013 14:16'!
defaultNameToSegmentIndex

	"Return a default object for instance variable nameToSegmentIndex."
	^Dictionary new! !

!WFWaffleSide methodsFor: 'accessing' stamp: 'hjo 11/28/2011 07:51'!
defaultRange

	^Range close: 0 open: 100! !

!WFWaffleSide methodsFor: 'segments' stamp: 'hjo 11/28/2011 12:01'!
defaultSegments

	^OrderedCollection new! !

!WFWaffleSide methodsFor: 'segments' stamp: 'hjo 11/28/2011 12:05'!
fixedSegments

	^self segments select: #lengthIsFixed! !

!WFWaffleSide methodsFor: 'accessing' stamp: 'hjo 11/28/2011 07:50'!
length

	^self range span! !

!WFWaffleSide methodsFor: 'computing' stamp: 'hjo 11/28/2011 12:20'!
lengthThatProportionalSegmentsMayDivide

	| result |
	result := self length - self sumOfLengthOfFixedSegments.
	self assert: [result >= 0].  
	^result! !

!WFWaffleSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/11/2013 13:40'!
name: aString boundaryAt: anInteger 
	self boundaryFromNameToIndex at: aString put: anInteger! !

!WFWaffleSide methodsFor: 'segments' stamp: 'HwaJong 2/11/2013 14:17'!
name: aString segmentAt: anInteger 
	self nameToSegmentIndex at: aString put: anInteger ! !

!WFWaffleSide methodsFor: 'accessing' stamp: 'HwaJong 2/11/2013 14:16'!
nameToSegmentIndex

	^nameToSegmentIndex setDefault: #defaultNameToSegmentIndex for: self withSetter: #nameToSegmentIndex:! !

!WFWaffleSide methodsFor: 'accessing' stamp: 'HwaJong 2/11/2013 14:16'!
nameToSegmentIndex: anObject
		
	nameToSegmentIndex := anObject! !

!WFWaffleSide methodsFor: 'segments' stamp: 'hjo 11/28/2011 12:06'!
proportionalSegments

	^self segments select: #lengthIsProportional! !

!WFWaffleSide methodsFor: 'accessing' stamp: 'hjo 11/28/2011 07:51'!
range

	^range setDefault: #defaultRange for: self withSetter: #range:! !

!WFWaffleSide methodsFor: 'accessing' stamp: 'HwaJong 1/13/2013 23:47'!
range: aRange 
	|oldRange|
	self absoluteLengthPerProportion: nil.
	oldRange := range.
	range := aRange.
	self length < self sumOfLengthOfFixedSegments
		ifTrue: 
			[range := oldRange.
			self error: 'aRange is too small to be make sense.' ].! !

!WFWaffleSide methodsFor: 'segments' stamp: 'HwaJong 12/29/2012 17:46'!
rangeOfIndentationAtIndex: anInteger
	self assert: [ self segments size >= 3 ] description: 'not enough segments'.
	^self rangeOfSegmentAtIndex: anInteger * 2! !

!WFWaffleSide methodsFor: 'segments' stamp: 'HwaJong 12/29/2012 17:42'!
rangeOfSegmentAtIndex: anInteger
	| rangeStart |
	rangeStart := self range start + (self sumOfLengthOfHeadingSegmentsUpTo: anInteger).
	^ Range close: rangeStart open: rangeStart + (self segments at: anInteger) length! !

!WFWaffleSide methodsFor: 'segments' stamp: 'HwaJong 1/15/2013 21:36'!
rangeStartOfSegmentAtIndex: anInteger
	^self range start + (self sumOfLengthOfHeadingSegmentsUpTo: anInteger).! !

!WFWaffleSide methodsFor: 'segments' stamp: 'HwaJong 2/11/2013 19:43'!
segmentByName: aString 
	^self segments at: (self nameToSegmentIndex at: aString)  ! !

!WFWaffleSide methodsFor: 'segments' stamp: 'hjo 11/28/2011 12:05'!
segmentOfIndentationAtIndex: anInteger 

	^self segments at: anInteger * 2! !

!WFWaffleSide methodsFor: 'segments' stamp: 'hjo 11/28/2011 12:12'!
segments

	^ segments setDefault: #defaultSegments for: self withSetter: #segments:! !

!WFWaffleSide methodsFor: 'segments' stamp: 'hjo 11/28/2011 12:12'!
segments: anOrderedCollection 

	segments := anOrderedCollection! !

!WFWaffleSide methodsFor: 'sum' stamp: 'hjo 11/28/2011 12:07'!
sumOfLengthOfFixedSegments
	
	| f |
	f := self fixedSegments collect: #length.
	^f isEmpty ifTrue: [0] ifFalse: [f sum].! !

!WFWaffleSide methodsFor: 'sum' stamp: 'HwaJong 12/29/2012 17:44'!
sumOfLengthOfHeadingSegmentsUpTo: anInteger
	^anInteger > 1
		ifTrue: 
			[ ((self segments copyFrom: 1 to: anInteger - 1) collect: #length) sum]
		ifFalse:
			[ 0 ]! !

!WFWaffleSide methodsFor: 'sum' stamp: 'hjo 11/28/2011 12:06'!
sumOfProportions

	^(self proportionalSegments collect: #proportion) sum! !
